Download it now!
Bug 45671 - Turn color etc. toolbar buttons into split buttons
Summary: Turn color etc. toolbar buttons into split buttons
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
3.5.0 release
Hardware: All All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard: target:3.6.0
Keywords:
: 64453 (view as bug list)
Depends on: 34425 44611 45682 45688 45689 45690 45692 46839 46840 74297 78810 89902
Blocks: Split-Group-Buttons
  Show dependency treegraph
 
Reported: 2012-02-06 01:14 UTC by Stefan Knorr (astron)
Modified: 2018-03-16 22:01 UTC (History)
3 users (show)

See Also:
Crash report or crash signature:


Attachments
Example for simple v/ split buttons (4.85 KB, image/png)
2012-02-06 01:14 UTC, Stefan Knorr (astron)
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Stefan Knorr (astron) 2012-02-06 01:14:04 UTC
Created attachment 56645 [details]
Example for simple v/ split buttons

This is a meta bug to collect all bugs concerning simple toolbar buttons that should be turned into split toolbar buttons.

Split buttons have the advantage that they can be used to pick the last used color (or other property) again witho only one click.

See attachment for an example of the look.
Comment 1 Winfried Donkers 2012-02-06 01:42:26 UTC
Buttons that should be split,as summarised by Astron so far (2012-02-03)

* Writer has two background colour functions, one is "Highlight" (can highlight single characters, words, etc. – the icon is a text marker) and the other is "Background Colour" (changes background colour for entire lines – icon is a page with a gradient, like in Calc). The highlighter is already a split button, but "Background Colour" is not.
* In Writer's Table toolbar, there are buttons for Background Colour and Line Colour
* Impress/Draw's Text Formatting toolbar contains a Font Colour button
* Impress/Draw's Table toolbar also contains a Line Colour button
* there are more places but those are probably less used/important, like the 3D-Settings toolbar(s)'s 3D Colour/Extrusion Colour (If you're feeling overwhelmed now, I'd offer to open bugs for all of the functions
Comment 2 Stefan Knorr (astron) 2012-02-06 04:29:03 UTC
Adding more dependencies...
To give an overview about the dependencies, currently:
Bug 34425 - [EasyHack] formatting background color toolbar button (for Calc)
Bug 44611 - UI: Paragraph Background Color picker behavior inconsistent (for Writer/Formatting, Writer/Table)
Bug 45688 - Calc: Formatting toolbar: Turn Button Font Color into Split Button
Bug 45682 - WRITER: Tables toolbar: Turn Button Line Color into Split Button
Bug 45689 - 3D-Settings toolbar: Turn Button 3D Color / Extrusion Color into Split Button
Bug 45690 - Impress/Draw: Text Formatting toolbar: Turn Button Font Color into Split Button
Bug 45692 - Impress/Draw: Tables toolbar: Turn Button Line Color into Split Button

Probably more to come.

Also see:
Bug 36646 -- this bug is far too broad but does describe some behavior that is different between different toolbar color buttons.
Comment 3 Not Assigned 2012-03-01 06:58:25 UTC
Winfried Donkers committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=085e8a07e61ef2d3a82e11094d8773ab17cfdb3c

fdo#45671 calc cell background color simplified code for split button
Comment 4 Not Assigned 2012-03-06 08:04:20 UTC
Winfried Donkers committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=f57e65477038e0151e1d69599351173ed2fdd044

fdo#45671 writer par. bg color simplified code
Comment 5 Not Assigned 2012-03-09 01:30:46 UTC
Winfried Donkers committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=0466a30ca52dc531887c75e2d42b007cc83778f3

fdo#45671 fix for transparent colour split button
Comment 6 Not Assigned 2012-03-15 09:05:22 UTC
Winfried Donkers committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=2e7e5e79c025b75fc01e600cc924f34b4c8b22ce

fdo#45671 split button for calc cell border color
Comment 7 Not Assigned 2012-03-21 03:48:34 UTC
Winfried Donkers committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=ae7c80640df922630060b82ffa91fd7db2e4d6d7

fdo#45671 set initial color for split buttons
Comment 8 Winfried Donkers 2012-03-21 08:58:33 UTC
status report:
The easy hacks have been submitted (and pushed), what still remains is more difficult.
Apart from the bugs filed and connected to this bug, I found two more buttons to be split in base (reportbuilder): both font and background colour. Presently the font colour is a split button, but it doesn't behave as it should (last used colour cannot be applied yet).

I now am concentrating on the two buttons in reportbuilder as hacking this succesfully means that a chunk of code can be removed (unused code).

@Astron:
Possibly there is more priority for another button. If that is the case, please tell me and I will try to adjust my labours to your priorities. I'm just a part timer, with a lot of other obligations coming up soon, so it may take some time before all colour buttons are fully functioning split buttons...
Comment 9 Stefan Knorr (astron) 2012-04-06 04:22:38 UTC
@Winfried: Thanks for doing this so far. Working on split buttons in Report Builder is appreciated, too.
I'd personally love to see the combo boxes in Impress/Draw's main toolbars gone. However, that is quite a bit harder, especially when it comes to the fill colors. (I'd love to see the fill type + fill color combo boxes combined into a single icon there, but haven't thought hard enough about how to best do this.)
Comment 10 Winfried Donkers 2012-04-06 08:41:58 UTC
(In reply to comment #9)
@Astron: Things pretty bleak right now, I keep 'running into blind alleys'.
-I have found no way to convert the report designer font/background colour buttons to split buttons, possibly becasue report designer is not a module as writer and calc are. By the way, the current button for report designer font colour _is_ a split button, (not done by me) but it doesn't work. Split buttons need to registered with the module there in..
-46839 (writer line colour) this control is of a completely differently type and doesn't allow straightforward conversion to split button. I don't know how and where the types of the controls of the UI are set.
-sd buttons: I will start on these in the hope that I can accomplish something here...
If not, I may be that I'll let it rest for a while or for someone else to pick up (I don't think the ones left are easyhacks)
Comment 11 NohWayJose 2012-06-10 04:23:59 UTC
In my related bug (36646) I mentioned a few use cases. I've just been playing with the Qt UI development IDE and the colour picker there does pretty much everything I mentioned. I know you can't use it but I just thought I'd mention it. A couple of points for you implementation for this bug, if I may...
a) Please make sure you highlight the current colour selection in the dropped down grid, as well as displaying it as the current colour in the un-dropped down control
b) Have a 'custom' entry in the grid which, when selected opens the native (Gnome/KDE/...) colour picker dialogue. In KDE, for example, I can then use a variety of colour models to select a custom colour and can even copy the colour value to the clipboard. The colour returned from this dialogue should be used as the background colour for the word 'custom'.

please, thank you :o)

Greg
Comment 12 Winfried Donkers 2013-04-18 10:52:35 UTC
While several buttons have been split, it seems that there is one small misbehaviour:

In the case of a background colour, the last used colour is visible in the button.
When selecting 'no fill' as new colour, the old colour remains.
Only after multiple use of the button does it show the 'no fill' colour.
Comment 13 Winfried Donkers 2013-04-23 07:58:30 UTC
(In reply to comment #12)
> While several buttons have been split, it seems that there is one small
> misbehaviour:
> 
> In the case of a background colour, the last used colour is visible in the
> button.
> When selecting 'no fill' as new colour, the old colour remains.
> Only after multiple use of the button does it show the 'no fill' colour.

There is a bug 56427 for this problem, which oly occurs in Windows (Calc and Writer).
Comment 14 Maxim Monastirsky 2014-06-18 12:01:56 UTC
*** Bug 64453 has been marked as a duplicate of this bug. ***
Comment 15 Ljiljan 2015-04-26 08:13:31 UTC
Comment to "a) Please make sure you highlight the current colour selection in the dropped down grid, as well as displaying it as the current colour in the un-dropped down control"

It is ok to display current colour selection in dropped down grip, but it should not be displayed in un-dropped down. Why? When you are trying to change color for different part of text, you want quickly to apply last used color. However, current colour should be visible in dropped down grid.
Comment 16 Thomas Lendo 2018-03-16 22:01:27 UTC
I set this bug to RESOLVED FIXED because
a) the bugs on which it depends are all fixed,
b) there's meta bug 103429 for all kind of Split-Group-Buttons,
c) several commits from 2012 are referenced in comments,
d) there's no activity for a long time.